# GlusterFS cheatsheet

## systemd
- systemctl enable glusterd
- systemctl start glusterd

## Peer Management
- gluster peer probe node1 node2 node3
- gluster peer detach node2 force
- gluster peer detach node3 force
- gluster peer status

## Volume Management
- gluster volume info
- gluster volume create gfs0-volume replica 3 node1:/gfs node2:/gfs node3:/gfs force
- gluster volume start gfs0-volume
- gluster volume set gfs0-volume auth.allow localhost
- gluster volume set gfs0-volume performance.cache-size 256MB
- gluster volume add-brick gfs0-volume replica 5 node4:/gfs node5:gfs
- gluster volume remove-brick gfs0-volume replica3 node4:/gfs node5:/gfs force
- gluster volume quota gfs0-volume enable
- gluster volume quota gfs0-volume limit-usage / 50GB
- gluster volume stop gfs0-volume force
- gluster volume delete gfs0-volume

## /etc/fstab
localhost:gfs0-volume /mnt/gfs-data glusterfs defaults,_netdev,noauto,x-systemd.automount 0 0
